# Copyright (c) 2024-2024, Huawei Technologies Co., Ltd.
# All rights reserved.
#
# Licensed under the Apache License, Version 2.0  (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cipher_list = ":".join(
    ["TLS_DHE_RSA_WITH_AES_128_GCM_SHA256",
     "TLS_DHE_RSA_WITH_AES_256_GCM_SHA384",
     "TLS_DHE_DSS_WITH_AES_128_GCM_SHA256",
     "TLS_DHE_DSS_WITH_AES_256_GCM_SHA384",
     "TLS_DHE_PSK_WITH_AES_128_GCM_SHA256",
     "TLS_DHE_PSK_WITH_AES_256_GCM_SHA384",
     "TLS_DHE_PSK_WITH_CHACHA20_POLY1305_SHA256",
     "TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256",
     "TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384",
     "TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256",
     "TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384",
     "TLS_ECDHE_RSA_WITH_CHACHA20_POLY1305_SHA256",
     "TLS_ECDHE_PSK_WITH_CHACHA20_POLY1305_SHA256",
     "TLS_ECDHE_PSK_WITH_AES_128_GCM_SHA256",
     "TLS_ECDHE_PSK_WITH_AES_256_GCM_SHA384",
     "TLS_ECDHE_PSK_WITH_AES_128_CCM_SHA256",
     "TLS_DHE_RSA_WITH_AES_128_CCM",
     "TLS_DHE_RSA_WITH_AES_256_CCM",
     "TLS_DHE_RSA_WITH_CHACHA20_POLY1305_SHA256",
     "TLS_DHE_PSK_WITH_AES_128_CCM",
     "TLS_DHE_PSK_WITH_AES_256_CCM",
     "TLS_ECDHE_ECDSA_WITH_AES_128_CCM",
     "TLS_ECDHE_ECDSA_WITH_AES_256_CCM",
     "TLS_ECDHE_ECDSA_WITH_CHACHA20_POLY1305_SHA256"]
).encode()

STRUCT_UNPACK_MODE = "!Q"
STR_TO_BYTES_ORDER = "big"
